//**********************************
//START: Equation Include Prototypes




//END: Equation Include Prototypes
//**********************************
#include "Constants v10.h"

integer QEattr_GetColumnIndex(string whichAttrib)
{

	integer whichCol;
	integer numAttribsInGA;
	integer me, attribListIndex;
	
	me = MyBlockNumber();

	attribListIndex = GaGetIndex("_AttributeList");
	if(AttribListIndex >= 0)
		{
		numAttribsInGA = GAGetRowsByIndex(attribListIndex);
	
		if(whichAttrib == "None"  ||  whichAttrib == "New attribute")
			whichCol = PROPERTY_TYPE_NO_PROPERTY;
				
		else if(whichAttrib == "_Item quantity")
			whichCol = PROPERTY_TYPE_ITEM_QUANTITY;
				
		else if(whichAttrib == "_Item priority")
			whichCol = PROPERTY_TYPE_ITEM_PRIORITY;
				
		else if(whichAttrib == "_AR Order ID")
			whichCol = PROPERTY_TYPE_AR_ORDER_ID;
				
		else if(whichAttrib == "_Item index")
			whichCol = PROPERTY_TYPE_ITEM_INDEX;
				
		else if(whichAttrib == "_Batch size")
			whichCol = PROPERTY_TYPE_ITEM_BATCH_SIZE;
	
		else if(whichAttrib == "_Animation")		//6/24/09: Added "_Animation" to the list of attribute types so that the animation attribute will return column 0
			whichCol = 0;
	
		else if(whichAttrib == "_3D object ID")
			whichCol = PROPERTY_TYPE_ITEM_3D_OBJECT_ID;
	
//		else if(whichAttrib == "_cost")												//8/31/17
		else if(whichAttrib == "_cost"  &&  sysGlobalInt16)							//8/31/17
			whichCol = numAttribsInGA + 1;	//+1 for BTB animation attrib
	
//		else if(whichAttrib == "_rate")							//1 + _cost = 2;	//8/31/17
		else if(whichAttrib == "_rate"  &&  sysGlobalInt16)		//1 + _cost = 2;	//8/31/17
			whichCol = numAttribsInGA + 2;
	
		else
			{
			//whichCol = GAFindStringAny(AttribListIndex, whichAttrib, 0, numAttribsInGA, 15, FALSE) + 1;		//5/20/09
			whichCol = GAFindStringAny(AttribListIndex, whichAttrib, 0, numAttribsInGA, 15, FALSE);	
			
			if(whichCol >= 0)	//ie, if whichAttrib was found in the _AttributeList GA
				whichCol = whichCol + 1;													//+1 because BTB animation attrib is column 0
			}
		}
	else
		{
		UserError("There is a problem in " + BlockName(me) + " " + me + ".  Please contact Imagine That.");
		AbortAllSims();
		}

	return(whichCol);

}//integer Attrib_GetColumnIndex(string whichAttrib)
//______________________________________________________________________________________________
//
procedure QEattr_setAttributeValue(string attributeName, integer itemIndex, real attributeValue)
{
	integer attribValuesIndex, columnIndex;
	
	attribValuesIndex = GaGetIndex("_AttribValues");

//	Get the column index of the specified attribute
	columnIndex = QEattr_GetColumnIndex(attributeName);
	GASetReal(attributeValue, attribValuesIndex, itemIndex, columnIndex);
}


